<?php

/* 
 * Itemstats update script
 * started: 31/05/2007
 *
 * author: Frank Matheron
 * email: fenuzz@gmail.com
 * description: simple script that updates all your cached item tooltips
 * usage: set the correct path to your itemstats root dir and run this script 
 *
 * version: 0.2.3
 * history: 0.2.3 (2/06/2007)
 *		- fixed the 'Cannot modify header information' bug
 *	    0.2.2 (1/06/2007)
 *		- fixed inaccurate progress display and skipping of items when nearing 100%
 *	    0.2.1 (1/06/2007)
 *		- no longer uses eqdkp
 *	    0.2.0 (1/06/2007) 	
 *		- updates all items in your item_cache table
 *              - progress indicator added   
 *          0.1.0 (31/05/2007)	
 *		- updates all itemstats tooltips for the items dropped in your dkp system
 *
 */

//
// Configuration
//
// path to the itemstats root dir
$path_itemstats = './';
// amount of items to update before refreshing the status
$step = 50;
//
// 
//

include_once(dirname(__FILE__) . '/config.php');
include_once(dirname(__FILE__) . '/itemstats.php');
include_once(dirname(__FILE__) . 'includes/sqlhelper.php');

if (isset($_GET['start']) && is_numeric($_GET['start']) && $_GET['start'] > 0) {	
	$begin = intval($_GET['start']);
} else {
	$begin = 0;
}

// open db connection
//echo $path_itemstats;
/*$sqlhelper = new SqlHelper(dbhost, dbname, dbuser, dbpass);
if (!$sqlhelper->connected) {
	echo "Could not connect to the database.";
	die();
}*/

if (isset($_GET['do'])) {
	//
	// update $step amount of items starting at $start/begin
	//

	$sql = "SELECT item_name FROM ".item_cache_table." LIMIT $begin, $step";

	
$result = $db->sql_query($sql);
	
	while ($row = $db->sql_fetchrow($result)) {
		$item_stats = new ItemStats();
		$item_stats->updateItem($row['item_name']);
	}
	
	$db->sql_freeresult($result);

	// set the start of the next batch of items to update
	$begin += $step;
	
	// redirect to show status
	header('Location: /index.php?name=item_stats&file=updateallitems&start=' . $begin);
} else {
	//
	// show updating status
	//
	$total = 0;
	// get the total amount of items to update
	$sql = 'SELECT COUNT(*) as total FROM '.item_cache_table.'';
	$result = $db->sql_query($sql);

	if ( $row = $db->sql_fetchrow($result) ) {
		$total = $row['total'];
	}	
	
	$db->sql_freeresult($result);

	// calculate at what percentage we are
	if ($begin >= $total) {
		$progress = 100;
		$begin = $total;
		header('Refresh: 0; url=/index.php?name=item_stats');
		break;
	} else {
		$progress = ceil(($begin / $total) * 100);
	}
	
	// if we havent updated all items, update the next batch of items
	if ($begin < $total) {
		header('Refresh: 0; url=/index.php?name=item_stats&file=updateallitems&start=' . $begin . '&do');
	} 

	// output status
	echo '<html>';
	echo '<head>';
	echo "<title>Itemstats Tooltips - $progress</title>";
	echo '</head>';
	echo '<body>';
	echo "Updating itemstats tooltips: $begin/$total ($progress%)";
	echo '</body>';
	echo '</html>';	
	
}

// close the db connection
//$db->close();

?>